package model.Actions;

import model.Player;

public abstract class Action {
	protected Player active;
	protected Player target;
	protected String name;
	protected String flag = "";
	protected int step;

	/* Mtodos abstratos que caracterizam uma ao e 
	 * devem ser implementados pelas subclasses */
	
	protected abstract void execute();
	public abstract void initialize();
	public abstract void step();
	public abstract void setStartStepFor(Action action);

	/* Getters */
	
	public String getName(){
		return this.name;
	}
	
	public int getStep(){
		return step;
	}
	
	/**
	 * Construtor genrico de uma ao qualquer.
	 * @param name Nome da ao.
	 * @param active O personagem executando a ao.
	 * @param target O personagem alvo da ao.
	 */
	public Action (String name, Player active, Player target){
		this.name = name;
		this.active = active;
		this.target = target;
	}
	
	/**
	 * Mtodo que avisa a ao que uma prxima ao est na fila.
	 * @param flag
	 */
	public void setFlag(String flag) {
		this.flag = flag;
	}
}
