package model.Actions;

import model.Arena;
import model.Player;

public class Clone extends Action {

	/**
	 * Construtor da classe Clone.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public Clone(String name, Player active, Player target) {
		super(name, active, target);
	}
	
	/**
	 * Mtodo que executa a ao criando os clones em torno do personagem executando a ao.
	 */
	protected void execute() {
		Player clone;
		this.active.setHasCloned(true);
		for (double i = 0; i < 2*Math.PI; i += 2*Math.PI/5){
			clone = new Player();
			clone.setLocation(this.active.getX() + 3*Math.cos(i), this.active.getY() + 3*Math.sin(i));
			clone.setDirection(this.active.getDirX(), this.active.getDirY());
			clone.setHasCloned(true);
			Arena.instanceOf().addPlayer(clone);			
		}
		this.active.endAction();
	}

	public void initialize() {
	}

	/**
	 * Atualiza o passo da animao.
	 */
	public void step() {
		this.step = (step + 1)%40;
		if (this.step == 0){
			this.execute();
		}
	}

	/**
	 * Inicia a animao no primeiro quadro.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;
	}

}
