package model.Actions;

import model.Player;

public class DoNothing extends Action {

	/**
	 * Construtor da classe DoNothing.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao. No usado.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public DoNothing(String name, Player active, Player target) {
		super(name, active, target);
	}

	/**
	 * Essa ao no tem efeitos, como seu nome sugere.
	 */
	protected void execute() {
	}

	public void initialize() {
	}

	
	/**
	 * Faz um passo de ao.
	 * Verifica se e quando essa ao deve terminar de acordo com a prxima ao
	 * a ser executada, que fica armazenado em flag.
	 */
	public void step() {
		this.step = (this.step + 1)%1;
		if (this.step == 0){
			if (!this.flag.equals("")){
				this.active.endAction();
			}
		}
	}

	/**
	 * Determina qual o passo inicial da animao da ao.
	 * Ele sempre comea essa ao no primeiro passo na animao.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;		
	}

}
