package model.Actions;

import model.Player;

public class Hadoken extends Action {
	private int count;
	
	
	/**
	 * Construtor da classe Hadoken.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public Hadoken(String name, Player active, Player target) {
		super(name, active, target);
	}
	
	/**
	 * Executa a ao, atualizando o quadro da animao. 
	 */
	protected void execute() {
		this.step = (this.step + 1)%40;
		if (this.step == 0){
			this.active.endAction();			
		}
	}
	
	/**
	 * Inicializa o contador para a velocidade de animao.
	 */
	public void initialize() {
		this.count=0;
	}
	
	/**
	 * Atualiza o contador e executa a ao sempre que adequado.
	 */
	public void step() {
		if (this.count > 20 && this.count < 23){
			this.count = (this.count + 1)%30;
		}
		else {
			this.count = (this.count + 1)%3;
		}
		if (this.count == 0){
			this.execute();
		}
	}
	
	/**
	 * Inicializa o quadro da animao.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;
	}
}
