package model.Actions;

import model.Player;

public class Jump extends Action {
	private int cycle;
	private double dirx, diry;

	/**
	 * Construtor da classe Jump.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public Jump(String name, Player active, Player target) {
		super(name, active, target);
	}
	
	/**
	 * Executa a ao, atualizando a posio do personagem se ele estiver em movimento durante o pulo.
	 */
	protected void execute() {
		if (this.active.isMoving()){
			this.active.setLocation(
					this.active.getX() + this.dirx, 
					this.active.getY() + this.diry);
		}
	}
	
	public void initialize() {
	}
	
	/**
	 * Faz um passo de ao.
	 * Verifica se e quando essa ao deve terminar de acordo com a prxima ao
	 * a ser executada, que fica armazenado em flag.
	 */
	public void step() {
		this.step = (step + 1)%40/*this.cycle*/;
		if (this.cycle == 60 && this.step > 35){
			this.dirx *= (2.0/3.0);
			this.diry *= (2.0/3.0);
		}
		this.execute();
		if (this.step == 0){
			this.active.setMoving(false);
			this.active.endAction();
		}
	}

	/**
	 * Determina qual o passo inicial da animao da ao.
	 * Depende de qual era a ao anterior para decidir isso.
	 */
	public void setStartStepFor(Action action) {
		if (action.getName().equals("Run")){
			this.step = 0;
			this.cycle = 60;
			double distance;
			distance = Math.sqrt(active.getDirX() * active.getDirX() + active.getDirY() * active.getDirY());
			this.dirx = active.getDirX()/(6*distance);
			this.diry = active.getDirY()/(6*distance);
			this.name = "RunningJump";
		}
		else {
			this.cycle = 40;
			this.step = 0;
		}
	}
}
