package model.Actions;

import model.Player;

public class Punch extends Action {
	private int count;

	/**
	 * Construtor da classe Punch.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public Punch(String name, Player active, Player target) {
		super(name, active, target);
	}

	/**
	 * Atualiza o quadro da animao.
	 */
	protected void execute() {
		this.step = (this.step + 1)%40;
		if (this.step == 0){
			this.active.endAction();			
		}
	}

	/**
	 * Inicializa o contador para a velocidade na animao.
	 */
	public void initialize() {
		this.count=0;
	}

	/**
	 * Atualiza o contador para a velocidade na animao, executa quando apropriado.
	 */
	public void step() {
		this.count = (this.count + 1)%2;
		if (this.count == 0){
			this.execute();
		}
	}

	/**
	 * Inicializa a animao no primeiro quadro.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;
	}
}
