package model.Actions;

import model.Arena;
import model.Player;

public class Teleport extends Action {
	
	/**
	 * Construtor da classe Teleport.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um personagem que armazena a posio alvo de teleporte.
	 */
	public Teleport(String name, Player active, Player target) {
		super(name, active, target);
	}

	/**
	 * Atualiza a posio do personagem para a posio desejada.
	 */
	protected void execute() {
		this.active.setLocation(this.target.getX(), this.target.getY());
	}

	public void initialize() {
		Arena.instanceOf().setCliked(true);
		Arena.instanceOf().setAuraPoint(this.target.getX(), this.target.getY());
	}
	
	/**
	 * Faz um passo de ao.
	 * Verifica se e quando essa ao deve terminar de acordo com a prxima ao
	 * a ser executada, que fica armazenado em flag.
	 */
	public void step() {
		this.step = (step + 1)%40;
		if (this.step == 20){
			this.execute();
		}
		if (this.step == 0){
			this.active.endAction();
		}
	}

	/**
	 * Determina qual o passo inicial da animao da ao.
	 * Depende de qual era a ao anterior para decidir isso.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;
	}
}
