package model.Actions;

import model.Player;

public class Wave extends Action {
	private int count;

	/**
	 * Construtor da classe Wave.
	 * @param name O nome da ao.
	 * @param active O personagem que vai executar a ao.
	 * @param target Um campo genrico nulo que no ser usado.
	 */
	public Wave(String name, Player active, Player target) {
		super(name, active, target);
	}

	/**
	 * Atualiza o quadro da animao.
	 */
	protected void execute() {
		this.step = (this.step + 1)%40;
		if (this.step == 0){
			this.active.endAction();			
		}
	}

	/**
	 * Inicializa o contador de velocidade com 0.
	 */
	public void initialize() {
		this.count=0;
	}
	
	/**
	 * Atualiza o contador de velocidade da animao.
	 */
	public void step() {
		this.count = (this.count + 1)%1;
		if (this.count == 0){
			this.execute();
		}
	}

	/**
	 * Inicializa o primeiro passo da animao no primeiro quadro.
	 */
	public void setStartStepFor(Action action) {
		this.step = 0;
	}
}
