package model;

import java.util.LinkedList;

public class Arena {
	private static Arena instance = null;
	private LinkedList<Player> bobs;
	private Player selected;
	private boolean cliked;
	private double xClick = 0, yClick = 0;
	
	/* Getters */

	public LinkedList<Player> getBobs() {
		return bobs;
	}
	
	public Player getSelected(){
		return this.selected;
	}

	public boolean isCliked() {
		return cliked;
	}
	
	public double getXClick() {
		return xClick;
	}

	public double getYClick() {
		return yClick;
	}

	/* Setters */

	public void setSelected(Player selected) {
		this.selected = selected;
	}

	public void setCliked(boolean cliked) {
		this.cliked = cliked;
	}
	
	public void setAuraPoint(double x, double y){
		this.xClick = x;
		this.yClick = y;
	}
	
	/**
	 * Mtodo de acesso  instancia da classe Arena.
	 * Se a instncia for nula, ela  inicializada.
	 * @return Uma instncia da classe Arena.
	 */
	public static Arena instanceOf(){
		if (instance == null){
			new Arena();
		}
		return instance;
	}
	
	/**
	 * Construtor da classe Arena.
	 * Inicializa a lista de personagens, adiciona um primeiro personagem e seleciona ele.
	 */
	public Arena (){
		Arena.instance = this;
		this.bobs = new LinkedList<Player>();
		this.bobs.add(new Player());
		this.selected = this.bobs.getFirst();
		this.cliked = false;
	}
	
	/**
	 * Adiciona um novo  para a lista de personagens na Arena.
	 * @param player O novo  a ser adicionado.
	 */
	public void addPlayer(Player player){
		this.bobs.addLast(player);
	}
}
