package view;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import controler.GameControler;
import controler.InputHandler;

public class KeyboardInputHandler implements KeyListener{
	private static KeyboardInputHandler instance = null;
	
	/**
	 * Construtor da classe KeyboardInputHandler.
	 * Armazena em instance a instncia da classe KeyboardInputHandler, para que exista apenas uma referncia.
	 */
	public KeyboardInputHandler (){
		KeyboardInputHandler.instance = this;
	}
	
	/**
	 * Mtodo de acesso  instancia da classe KeyboardInputHandler.
	 * esse mtodo deve ser chamado depois da inicializacao da instncia atravs do construtor
	 * @return Uma instncia da classe KeyboardInputHandler.
	 */
	public static KeyboardInputHandler instanceOf(){
		return instance;
	}
	
	/**
	 * Mtodo para o tratamento de uma tecla sendo apertada, no momento nada
	 *  feito, mas pode ser usado para tratar eventos como "ctrl+a" difetente de "a"
	 */
	public void keyPressed(KeyEvent e) {
	}
	
	/**
	 * Mtodo para o tratamento de uma tecla sendo solta, no momento nada
	 *  feito, mas pode ser usado para tratar eventos como "ctrl+a" difetente de "a"
	 */
	public void keyReleased(KeyEvent e) {
	}
	
	/**
	 * Mtodo para o tratamento de uma tecla sendo digitada,
	 * dependendo da tecla o mtodo a reconhece como um atalho para alguma ao e 
	 * chama o InputHandler para lidar com esse comando do usurio.
	 */
	public void keyTyped(KeyEvent e) {
		char c = e.getKeyChar();
		if(c == 'k')
			InputHandler.instanceOf().pressButton("Kick");
		else if (c == 'p')
			InputHandler.instanceOf().pressButton("Punch");
		else if (c == 'j')
			InputHandler.instanceOf().pressButton("Jump");
		else if (c == 'w')
			InputHandler.instanceOf().pressButton("Wave");
		else if (c == 'h')
			InputHandler.instanceOf().pressButton("Hadoken");
		else if (c == 'c')
			InputHandler.instanceOf().pressButton("Clone");
		else if (c == 'a')
			InputHandler.instanceOf().oneClickOn(40, 5);
		else if (c == 's')
			InputHandler.instanceOf().twoClickOn(5, 5);
		else if (c == 'd')
			InputHandler.instanceOf().twoClickOn(40, 25);
		else if (c == 'f')
			InputHandler.instanceOf().oneClickOn(5, 25);
		else if (c == '+')
			GameControler.instanceOf().faster();
		else if (c == '-')
			GameControler.instanceOf().slower();
	}	
}
