package view;

import java.io.File;
import java.io.IOException;
import javax.media.opengl.GLException;
import com.sun.opengl.util.texture.*;

public class TextureHandler {
	
	private static TextureHandler instance = null;
	
	private int numberOfTextures;
	private Texture[] textures;
	private String path;
	private boolean texturesLoaded = false;  //Avoids problems like reloading textures

	/**
	 * Construtor da classe TextureHandler.
	 * Armazena em instance a instncia da classe, para que exista apenas uma referncia.
	 * Alm disso inicializa o vetor de texturas com o nmero total de texturas da aplicao
	 */
	public TextureHandler(String Path){
		numberOfTextures = 6;
		textures = new Texture[numberOfTextures];
		path = Path;
		TextureHandler.instance = this;
	}

	/**
	 * Mtodo de acesso  instancia da classe TextureHandler.
	 * esse mtodo deve ser chamado depois da inicializacao da instncia atravs do construtor
	 * @return Uma instncia da classe TextureHandler.
	 */
	public static TextureHandler instanceOf(){
		return instance;
	}

	/**
	 * Mtodo que carrega as texturas de imagens, criando elas e armazenando-as em um vetor
	 */
	public void loadTextures() { 
		if(!texturesLoaded){
			try {
				File f = new File(path+"tile1.jpg");
				File g = new File(path+"Wood1.jpg");
				File h = new File(path+"borda1.jpg");
				File i = new File(path+"chao1.jpg");
				File j = new File(path+"parede1.jpg");
				File k = new File(path+"ceu1.jpg");
				textures[0] = TextureIO.newTexture(f, true);
				textures[1] = TextureIO.newTexture(g, true);
				textures[2] = TextureIO.newTexture(h, true);
				textures[3] = TextureIO.newTexture(i, true);
				textures[4] = TextureIO.newTexture(j, true);
				textures[5] = TextureIO.newTexture(k, true);
			}
			catch(IOException e) {
				e.printStackTrace();
			}
			catch(GLException e) {
				e.printStackTrace();
			}
			texturesLoaded = true;
		}
	}

	/**
	 * Mtodo de acesso s texturas
	 * @param index  o indice da textura desejada
	 * @return a textura no indice passado
	 */
	public Texture getTextureAt(int index){
		return textures[index];
	}

}
